(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common/http'), require('rxjs'), require('rxjs/operators'), require('url'), require('hash.js')) :
    typeof define === 'function' && define.amd ? define('angular4-hal-redux', ['exports', '@angular/core', '@angular/common/http', 'rxjs', 'rxjs/operators', 'url', 'hash.js'], factory) :
    (global = global || self, factory(global['angular4-hal-redux'] = {}, global.ng.core, global.ng.common.http, global.rxjs, global.rxjs.operators, global.url, global.hash_js));
}(this, function (exports, core, http, rxjs, operators, url, hash_js) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */

    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @template T
     */
    var   /**
     * @template T
     */
    ResourceArray = /** @class */ (function () {
        function ResourceArray() {
            this.totalElements = 0;
            this.totalPages = 1;
            this.pageNumber = 1;
            this.result = [];
        }
        /**
         * @private
         * @param {?} query
         * @param {?} field
         * @param {?} value
         * @return {?}
         */
        ResourceArray.replaceOrAdd = /**
         * @private
         * @param {?} query
         * @param {?} field
         * @param {?} value
         * @return {?}
         */
        function (query, field, value) {
            if (query) {
                /** @type {?} */
                var idx = query.indexOf(field);
                /** @type {?} */
                var idxNextAmp = query.indexOf('&', idx) === -1 ? query.indexOf('/', idx) : query.indexOf('&', idx);
                if (idx !== -1) {
                    /** @type {?} */
                    var searchValue = query.substring(idx, idxNextAmp);
                    query = query.replace(searchValue, field + '=' + value);
                }
                else {
                    query = query.concat('&' + field + '=' + value);
                }
            }
            else {
                query = '?' + field + '=' + value;
            }
            return query;
        };
        /**
         * @param {?} el
         * @return {?}
         */
        ResourceArray.prototype.push = /**
         * @param {?} el
         * @return {?}
         */
        function (el) {
            this.result.push(el);
        };
        /**
         * @return {?}
         */
        ResourceArray.prototype.length = /**
         * @return {?}
         */
        function () {
            return this.result.length;
        };
        // Load next page
        // Load next page
        /**
         * @param {?} type
         * @return {?}
         */
        ResourceArray.prototype.next = 
        // Load next page
        /**
         * @param {?} type
         * @return {?}
         */
        function (type) {
            var _this = this;
            if (this.next_uri) {
                return ResourceHelper.getHttp().get(ResourceHelper.getProxy(this.next_uri), {
                    headers: ResourceHelper.headers,
                    observe: 'response'
                }).pipe(operators.map((/**
                 * @param {?} response
                 * @return {?}
                 */
                function (response) { return _this.init(type, response, _this.sortInfo); })), operators.catchError((/**
                 * @param {?} error
                 * @return {?}
                 */
                function (error) { return rxjs.throwError(error); })));
            }
            return rxjs.throwError('no next defined');
        };
        /**
         * @param {?} type
         * @return {?}
         */
        ResourceArray.prototype.prev = /**
         * @param {?} type
         * @return {?}
         */
        function (type) {
            var _this = this;
            if (this.prev_uri) {
                return ResourceHelper.getHttp().get(ResourceHelper.getProxy(this.prev_uri), {
                    headers: ResourceHelper.headers,
                    observe: 'response'
                }).pipe(operators.map((/**
                 * @param {?} response
                 * @return {?}
                 */
                function (response) { return _this.init(type, response, _this.sortInfo); })), operators.catchError((/**
                 * @param {?} error
                 * @return {?}
                 */
                function (error) { return rxjs.throwError(error); })));
            }
            return rxjs.throwError('no prev defined');
        };
        /**
         * @param {?} type
         * @return {?}
         */
        ResourceArray.prototype.first = /**
         * @param {?} type
         * @return {?}
         */
        function (type) {
            var _this = this;
            if (this.first_uri) {
                return ResourceHelper.getHttp().get(ResourceHelper.getProxy(this.first_uri), {
                    headers: ResourceHelper.headers,
                    observe: 'response'
                }).pipe(operators.map((/**
                 * @param {?} response
                 * @return {?}
                 */
                function (response) { return _this.init(type, response, _this.sortInfo); })), operators.catchError((/**
                 * @param {?} error
                 * @return {?}
                 */
                function (error) { return rxjs.throwError(error); })));
            }
            return rxjs.throwError('no first defined');
        };
        // Load first page
        // Load first page
        /**
         * @param {?} type
         * @return {?}
         */
        ResourceArray.prototype.last = 
        // Load first page
        /**
         * @param {?} type
         * @return {?}
         */
        function (type) {
            var _this = this;
            if (this.last_uri) {
                return ResourceHelper.getHttp().get(ResourceHelper.getProxy(this.last_uri), {
                    headers: ResourceHelper.headers,
                    observe: 'response'
                }).pipe(operators.map((/**
                 * @param {?} response
                 * @return {?}
                 */
                function (response) { return _this.init(type, response, _this.sortInfo); })), operators.catchError((/**
                 * @param {?} error
                 * @return {?}
                 */
                function (error) { return rxjs.throwError(error); })));
            }
            return rxjs.throwError('no last defined');
        };
        // Load last page
        // Load last page
        /**
         * @param {?} type
         * @param {?} pageNumber
         * @return {?}
         */
        ResourceArray.prototype.page = 
        // Load last page
        /**
         * @param {?} type
         * @param {?} pageNumber
         * @return {?}
         */
        function (type, pageNumber) {
            var _this = this;
            this.self_uri = this.self_uri.replace('{?page,size,sort,projection}', '');
            this.self_uri = this.self_uri.replace('{&sort}', '');
            /** @type {?} */
            var urlParsed = url.parse(ResourceHelper.getProxy(this.self_uri));
            /** @type {?} */
            var query = ResourceArray.replaceOrAdd(urlParsed.query, 'size', this.pageSize.toString());
            query = ResourceArray.replaceOrAdd(query, 'page', pageNumber.toString());
            /** @type {?} */
            var uri = urlParsed.query ?
                ResourceHelper.getProxy(this.self_uri).replace(urlParsed.query, query) : ResourceHelper.getProxy(this.self_uri).concat(query);
            uri = this.addSortInfo(uri);
            return ResourceHelper.getHttp().get(uri, {
                headers: ResourceHelper.headers,
                observe: 'response'
            }).pipe(operators.map((/**
             * @param {?} response
             * @return {?}
             */
            function (response) { return _this.init(type, response, _this.sortInfo); })), operators.catchError((/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return rxjs.throwError(error); })));
        };
        // Load page with given pageNumber
        // Load page with given pageNumber
        /**
         * @param {?} type
         * @param {...?} sort
         * @return {?}
         */
        ResourceArray.prototype.sortElements = 
        // Load page with given pageNumber
        /**
         * @param {?} type
         * @param {...?} sort
         * @return {?}
         */
        function (type) {
            var _this = this;
            var sort = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                sort[_i - 1] = arguments[_i];
            }
            this.self_uri = this.self_uri.replace('{?page,size,sort}', '');
            this.self_uri = this.self_uri.replace('{&sort}', '');
            /** @type {?} */
            var uri = ResourceHelper.getProxy(this.self_uri).concat('?', 'size=', this.pageSize.toString(), '&page=', this.pageNumber.toString());
            uri = this.addSortInfo(uri);
            return ResourceHelper.getHttp().get(uri, {
                headers: ResourceHelper.headers,
                observe: 'response'
            }).pipe(operators.map((/**
             * @param {?} response
             * @return {?}
             */
            function (response) { return _this.init(type, response, sort); })), operators.catchError((/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return rxjs.throwError(error); })));
        };
        // Sort collection based on given sort attribute
        // Sort collection based on given sort attribute
        /**
         * @param {?} type
         * @param {?} size
         * @return {?}
         */
        ResourceArray.prototype.size = 
        // Sort collection based on given sort attribute
        /**
         * @param {?} type
         * @param {?} size
         * @return {?}
         */
        function (type, size) {
            var _this = this;
            /** @type {?} */
            var uri = ResourceHelper.getProxy(this.self_uri).concat('?', 'size=', size.toString());
            uri = this.addSortInfo(uri);
            return ResourceHelper.getHttp().get(uri, {
                headers: ResourceHelper.headers,
                observe: 'response'
            }).pipe(operators.map((/**
             * @param {?} response
             * @return {?}
             */
            function (response) { return _this.init(type, response, _this.sortInfo); })), operators.catchError((/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return rxjs.throwError(error); })));
        };
        // Load page with given size
        // Load page with given size
        /**
         * @private
         * @param {?} type
         * @param {?} response
         * @param {?} sortInfo
         * @return {?}
         */
        ResourceArray.prototype.init = 
        // Load page with given size
        /**
         * @private
         * @param {?} type
         * @param {?} response
         * @param {?} sortInfo
         * @return {?}
         */
        function (type, response, sortInfo) {
            /** @type {?} */
            var result = ResourceHelper.createEmptyResult(this._embedded);
            result.sortInfo = sortInfo;
            ResourceHelper.instantiateResourceCollection(type, response, result);
            return result;
        };
        /**
         * @private
         * @param {?} uri
         * @return {?}
         */
        ResourceArray.prototype.addSortInfo = /**
         * @private
         * @param {?} uri
         * @return {?}
         */
        function (uri) {
            var e_1, _a;
            if (this.sortInfo) {
                try {
                    for (var _b = __values(this.sortInfo), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var item = _c.value;
                        uri = uri.concat('&sort=', item.path, ',', item.order);
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
            }
            return uri;
        };
        return ResourceArray;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var Utils = /** @class */ (function () {
        function Utils() {
        }
        /**
         * @param {?} value
         * @return {?}
         */
        Utils.isNullOrUndefined = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            return value === null || value === undefined;
        };
        /**
         * @param {?} value
         * @return {?}
         */
        Utils.isPrimitive = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            return (typeof value !== 'object' && typeof value !== 'function') || value === null;
        };
        return Utils;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // @dynamic
    var   
    // @dynamic
    ResourceHelper = /** @class */ (function () {
        function ResourceHelper() {
        }
        Object.defineProperty(ResourceHelper, "headers", {
            get: /**
             * @return {?}
             */
            function () {
                if (Utils.isNullOrUndefined(this._headers)) {
                    this._headers = new http.HttpHeaders();
                }
                return this._headers;
            },
            set: /**
             * @param {?} headers
             * @return {?}
             */
            function (headers) {
                this._headers = headers;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} params
         * @param {?=} options
         * @return {?}
         */
        ResourceHelper.optionParams = /**
         * @param {?} params
         * @param {?=} options
         * @return {?}
         */
        function (params, options) {
            var e_1, _a;
            if (options) {
                params = this.params(params, options.params);
                if (options.size) {
                    params = params.append('size', options.size.toString());
                }
                if (options.sort) {
                    try {
                        for (var _b = __values(options.sort), _c = _b.next(); !_c.done; _c = _b.next()) {
                            var s = _c.value;
                            /** @type {?} */
                            var sortString = '';
                            sortString = s.path ? sortString.concat(s.path) : sortString;
                            sortString = s.order ? sortString.concat(',').concat(s.order) : sortString;
                            params = params.append('sort', sortString);
                        }
                    }
                    catch (e_1_1) { e_1 = { error: e_1_1 }; }
                    finally {
                        try {
                            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                        }
                        finally { if (e_1) throw e_1.error; }
                    }
                }
            }
            return params;
        };
        /**
         * @param {?} httpParams
         * @param {?=} params
         * @return {?}
         */
        ResourceHelper.params = /**
         * @param {?} httpParams
         * @param {?=} params
         * @return {?}
         */
        function (httpParams, params) {
            var e_2, _a;
            if (params) {
                try {
                    for (var params_1 = __values(params), params_1_1 = params_1.next(); !params_1_1.done; params_1_1 = params_1.next()) {
                        var param = params_1_1.value;
                        httpParams = httpParams.append(param.key, param.value.toString());
                    }
                }
                catch (e_2_1) { e_2 = { error: e_2_1 }; }
                finally {
                    try {
                        if (params_1_1 && !params_1_1.done && (_a = params_1.return)) _a.call(params_1);
                    }
                    finally { if (e_2) throw e_2.error; }
                }
            }
            return httpParams;
        };
        /**
         * @param {?} resource
         * @return {?}
         */
        ResourceHelper.resolveRelations = /**
         * @param {?} resource
         * @return {?}
         */
        function (resource) {
            var _this = this;
            /** @type {?} */
            var result = {};
            var _loop_1 = function (key) {
                if (!Utils.isNullOrUndefined(resource[key])) {
                    if (ResourceHelper.className(resource[key])
                        .find((/**
                     * @param {?} className
                     * @return {?}
                     */
                    function (className) { return className === 'Resource'; })) || resource[key]._links) {
                        if (resource[key]._links) {
                            result[key] = resource[key]._links.self.href;
                        }
                    }
                    else if (Array.isArray(resource[key])) {
                        /** @type {?} */
                        var array = resource[key];
                        if (array) {
                            result[key] = [];
                            array.forEach((/**
                             * @param {?} element
                             * @return {?}
                             */
                            function (element) {
                                if (Utils.isPrimitive(element)) {
                                    result[key].push(element);
                                }
                                else {
                                    result[key].push(_this.resolveRelations(element));
                                }
                            }));
                        }
                    }
                    else {
                        result[key] = resource[key];
                    }
                }
            };
            for (var key in resource) {
                _loop_1(key);
            }
            return (/** @type {?} */ (result));
        };
        /**
         * @template T
         * @param {?} _embedded
         * @return {?}
         */
        ResourceHelper.createEmptyResult = /**
         * @template T
         * @param {?} _embedded
         * @return {?}
         */
        function (_embedded) {
            /** @type {?} */
            var resourceArray = new ResourceArray();
            resourceArray._embedded = _embedded;
            return resourceArray;
        };
        /**
         * @param {?} obj
         * @return {?}
         */
        ResourceHelper.getClassName = /**
         * @param {?} obj
         * @return {?}
         */
        function (obj) {
            /** @type {?} */
            var funcNameRegex = /function (.+?)\(/;
            /** @type {?} */
            var results = (funcNameRegex).exec(obj.constructor.toString());
            return (results && results.length > 1) ? results[1] : '';
        };
        /**
         * @param {?} objProto
         * @return {?}
         */
        ResourceHelper.className = /**
         * @param {?} objProto
         * @return {?}
         */
        function (objProto) {
            /** @type {?} */
            var classNames = [];
            /** @type {?} */
            var obj = Object.getPrototypeOf(objProto);
            /** @type {?} */
            var className;
            // tslint:disable-next-line:no-conditional-assignment
            while ((className = ResourceHelper.getClassName(obj)) !== 'Object') {
                classNames.push(className);
                obj = Object.getPrototypeOf(obj);
            }
            return classNames;
        };
        /**
         * @template T
         * @param {?} entity
         * @param {?} response
         * @return {?}
         */
        ResourceHelper.instantiateResourceFromResponse = /**
         * @template T
         * @param {?} entity
         * @param {?} response
         * @return {?}
         */
        function (entity, response) {
            if (response.status >= 200 && response.status <= 207) {
                return ResourceHelper.instantiateResource(entity, response.body);
            }
            else if (response.status === 404) {
                return null;
            }
        };
        /**
         * @template T
         * @param {?} type
         * @param {?} response
         * @param {?} result
         * @param {?=} builder
         * @return {?}
         */
        ResourceHelper.instantiateResourceCollection = /**
         * @template T
         * @param {?} type
         * @param {?} response
         * @param {?} result
         * @param {?=} builder
         * @return {?}
         */
        function (type, response, result, builder) {
            var e_3, _a, e_4, _b;
            if (response.status >= 200 && response.status <= 207) {
                /** @type {?} */
                var payload = response.body;
                if (payload[result._embedded]) {
                    try {
                        for (var _c = __values(Object.keys(payload[result._embedded])), _d = _c.next(); !_d.done; _d = _c.next()) {
                            var embeddedClassName = _d.value;
                            /** @type {?} */
                            var embedded = payload[result._embedded];
                            /** @type {?} */
                            var items = embedded[embeddedClassName];
                            try {
                                for (var items_1 = __values(items), items_1_1 = items_1.next(); !items_1_1.done; items_1_1 = items_1.next()) {
                                    var item = items_1_1.value;
                                    /** @type {?} */
                                    var instance = new type();
                                    instance = this.searchSubtypes(builder, embeddedClassName, instance);
                                    this.instantiateResource(instance, item);
                                    result.push(instance);
                                }
                            }
                            catch (e_4_1) { e_4 = { error: e_4_1 }; }
                            finally {
                                try {
                                    if (items_1_1 && !items_1_1.done && (_b = items_1.return)) _b.call(items_1);
                                }
                                finally { if (e_4) throw e_4.error; }
                            }
                        }
                    }
                    catch (e_3_1) { e_3 = { error: e_3_1 }; }
                    finally {
                        try {
                            if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
                        }
                        finally { if (e_3) throw e_3.error; }
                    }
                }
                result.totalElements = payload.page ? payload.page.totalElements : result.length;
                result.totalPages = payload.page ? payload.page.totalPages : 1;
                result.pageNumber = payload.page ? payload.page.number : 1;
                result.pageSize = payload.page ? payload.page.size : 20;
                result.self_uri = payload._links && payload._links.self ? payload._links.self.href : undefined;
                result.next_uri = payload._links && payload._links.next ? payload._links.next.href : undefined; // tslint:disable-line:max-line-length
                result.prev_uri = payload._links && payload._links.prev ? payload._links.prev.href : undefined; // tslint:disable-line:max-line-length
                result.first_uri = payload._links && payload._links.first ? payload._links.first.href : undefined; // tslint:disable-line:max-line-length
                result.last_uri = payload._links && payload._links.last ? payload._links.last.href : undefined; // tslint:disable-line:max-line-length
            }
            else if (response.status === 404) {
                result.result = [];
            }
            return result;
        };
        /**
         * @template T
         * @param {?} builder
         * @param {?} embeddedClassName
         * @param {?} instance
         * @return {?}
         */
        ResourceHelper.searchSubtypes = /**
         * @template T
         * @param {?} builder
         * @param {?} embeddedClassName
         * @param {?} instance
         * @return {?}
         */
        function (builder, embeddedClassName, instance) {
            if (builder && builder.subtypes) {
                /** @type {?} */
                var keys = builder.subtypes.keys();
                Array.from(keys).forEach((/**
                 * @param {?} subtypeKey
                 * @return {?}
                 */
                function (subtypeKey) {
                    if (embeddedClassName.toLowerCase().startsWith(subtypeKey.toLowerCase())) {
                        /** @type {?} */
                        var subtype = builder.subtypes.get(subtypeKey);
                        instance = new subtype();
                    }
                }));
            }
            return instance;
        };
        /**
         * @template T
         * @param {?} entity
         * @param {?} payload
         * @return {?}
         */
        ResourceHelper.instantiateResource = /**
         * @template T
         * @param {?} entity
         * @param {?} payload
         * @return {?}
         */
        function (entity, payload) {
            var e_5, _a;
            try {
                for (var _b = __values(Object.keys(payload)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var p = _c.value;
                    // TODO array initClearCacheProcess
                    /* if(entity[p].constructor === Array && isNullOrUndefined(payload[p]))
                         entity[p] = [];
                     else*/
                    entity[p] = payload[p];
                }
            }
            catch (e_5_1) { e_5 = { error: e_5_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_5) throw e_5.error; }
            }
            return entity;
        };
        /**
         * @param {?} proxy_uri
         * @return {?}
         */
        ResourceHelper.setProxyUri = /**
         * @param {?} proxy_uri
         * @return {?}
         */
        function (proxy_uri) {
            ResourceHelper.proxy_uri = proxy_uri;
        };
        /**
         * @param {?} root_uri
         * @return {?}
         */
        ResourceHelper.setRootUri = /**
         * @param {?} root_uri
         * @return {?}
         */
        function (root_uri) {
            ResourceHelper.root_uri = root_uri;
        };
        /**
         * @return {?}
         */
        ResourceHelper.getURL = /**
         * @return {?}
         */
        function () {
            return ResourceHelper.proxy_uri && ResourceHelper.proxy_uri !== '' ?
                ResourceHelper.addSlash(ResourceHelper.proxy_uri) :
                ResourceHelper.addSlash(ResourceHelper.root_uri);
        };
        /**
         * @param {?} uri
         * @return {?}
         */
        ResourceHelper.getProxy = /**
         * @param {?} uri
         * @return {?}
         */
        function (uri) {
            uri = uri.replace('{?projection}', '');
            if (!ResourceHelper.proxy_uri || ResourceHelper.proxy_uri === '') {
                return uri;
            }
            return ResourceHelper.addSlash(uri.replace(ResourceHelper.root_uri, ResourceHelper.proxy_uri));
        };
        /**
         * @param {?} http
         * @return {?}
         */
        ResourceHelper.setHttp = /**
         * @param {?} http
         * @return {?}
         */
        function (http) {
            this.http = http;
        };
        /**
         * @return {?}
         */
        ResourceHelper.getHttp = /**
         * @return {?}
         */
        function () {
            return this.http;
        };
        /**
         * @return {?}
         */
        ResourceHelper.getRootUri = /**
         * @return {?}
         */
        function () {
            return this.root_uri;
        };
        /**
         * @private
         * @param {?} uri
         * @return {?}
         */
        ResourceHelper.addSlash = /**
         * @private
         * @param {?} uri
         * @return {?}
         */
        function (uri) {
            /** @type {?} */
            var uriParsed = url.parse(uri);
            if (Utils.isNullOrUndefined(uriParsed.search) && uri && uri[uri.length - 1] !== '/') {
                return uri + '/';
            }
            return uri;
        };
        return ResourceHelper;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {number} */
    var EvictStrategy = {
        EvictTrivial: 0,
        EvictSmart: 1,
    };
    EvictStrategy[EvictStrategy.EvictTrivial] = 'EvictTrivial';
    EvictStrategy[EvictStrategy.EvictSmart] = 'EvictSmart';
    // @dynamic
    var CacheHelper = /** @class */ (function () {
        function CacheHelper() {
        }
        /**
         * @return {?}
         */
        CacheHelper.initClearCacheProcess = /**
         * @return {?}
         */
        function () {
            var _this = this;
            if (this.isActive) {
                setInterval((/**
                 * @return {?}
                 */
                function () {
                    if (CacheHelper.evictStrategy === EvictStrategy.EvictTrivial) {
                        _this.evictAll();
                    }
                    else if (CacheHelper.evictStrategy === EvictStrategy.EvictSmart) {
                        _this.cacheMap.forEach((/**
                         * @param {?} value
                         * @param {?} key
                         * @return {?}
                         */
                        function (value, key) {
                            if (value.expire > 0 && Date.now() > value.expire) {
                                _this.evict(key);
                            }
                        }));
                    }
                }), 15 * 60 * 1000);
            }
        };
        /**
         * @template T
         * @param {?} link
         * @param {?=} body
         * @param {?=} params
         * @param {?=} isActiveLocal
         * @return {?}
         */
        CacheHelper.ifPresent = /**
         * @template T
         * @param {?} link
         * @param {?=} body
         * @param {?=} params
         * @param {?=} isActiveLocal
         * @return {?}
         */
        function (link, body, params, isActiveLocal) {
            if (isActiveLocal === void 0) { isActiveLocal = true; }
            if (!this.isActive || !isActiveLocal) {
                return false;
            }
            return this.cacheMap.has(CacheHelper.key(link, body, params));
        };
        /**
         * @template T
         * @param {?} link
         * @param {?=} body
         * @param {?=} params
         * @return {?}
         */
        CacheHelper.getArray = /**
         * @template T
         * @param {?} link
         * @param {?=} body
         * @param {?=} params
         * @return {?}
         */
        function (link, body, params) {
            return this.cacheMap.get(CacheHelper.key(link, body, params)).entity;
        };
        /**
         * @template T
         * @param {?} link
         * @param {?} array
         * @param {?=} expireMs
         * @param {?=} body
         * @param {?=} params
         * @return {?}
         */
        CacheHelper.putArray = /**
         * @template T
         * @param {?} link
         * @param {?} array
         * @param {?=} expireMs
         * @param {?=} body
         * @param {?=} params
         * @return {?}
         */
        function (link, array, expireMs, body, params) {
            if (expireMs === void 0) { expireMs = 10 * 60 * 1000; }
            if (this.isActive) {
                /** @type {?} */
                var resourceExpire = {
                    entity: array,
                    expire: CacheHelper.expireDate(expireMs)
                };
                this.cacheMap.set(CacheHelper.key(link, body, params), resourceExpire);
            }
        };
        /**
         * @template T
         * @param {?} link
         * @param {?=} body
         * @param {?=} params
         * @return {?}
         */
        CacheHelper.get = /**
         * @template T
         * @param {?} link
         * @param {?=} body
         * @param {?=} params
         * @return {?}
         */
        function (link, body, params) {
            return this.cacheMap.get(CacheHelper.key(link, body, params)).entity;
        };
        /**
         * @template T
         * @param {?} link
         * @param {?} array
         * @param {?=} expireMs
         * @param {?=} body
         * @param {?=} params
         * @return {?}
         */
        CacheHelper.put = /**
         * @template T
         * @param {?} link
         * @param {?} array
         * @param {?=} expireMs
         * @param {?=} body
         * @param {?=} params
         * @return {?}
         */
        function (link, array, expireMs, body, params) {
            if (expireMs === void 0) { expireMs = 10 * 60 * 1000; }
            if (this.isActive) {
                /** @type {?} */
                var resourceExpire = {
                    entity: array,
                    expire: CacheHelper.expireDate(expireMs)
                };
                this.cacheMap.set(CacheHelper.key(link, body, params), resourceExpire);
            }
        };
        /**
         * @param {?} key
         * @return {?}
         */
        CacheHelper.evict = /**
         * @param {?} key
         * @return {?}
         */
        function (key) {
            this.cacheMap.delete(key);
        };
        /**
         * @return {?}
         */
        CacheHelper.evictAll = /**
         * @return {?}
         */
        function () {
            this.cacheMap.clear();
        };
        /**
         * @private
         * @param {?} expireMs
         * @return {?}
         */
        CacheHelper.expireDate = /**
         * @private
         * @param {?} expireMs
         * @return {?}
         */
        function (expireMs) {
            if (expireMs === 0) {
                return 0;
            }
            return Date.now() + expireMs;
        };
        /**
         * @private
         * @param {?} link
         * @param {?=} body
         * @param {?=} halOptions
         * @return {?}
         */
        CacheHelper.key = /**
         * @private
         * @param {?} link
         * @param {?=} body
         * @param {?=} halOptions
         * @return {?}
         */
        function (link, body, halOptions) {
            /** @type {?} */
            var k = link;
            if (body) {
                k += body;
            }
            if (halOptions) {
                k += CacheHelper.toStringParams(halOptions);
            }
            /** @type {?} */
            var key = hash_js.sha256().update(k).digest('hex');
            return key;
        };
        /**
         * @private
         * @param {?} options
         * @return {?}
         */
        CacheHelper.toStringParams = /**
         * @private
         * @param {?} options
         * @return {?}
         */
        function (options) {
            /** @type {?} */
            var s = '';
            if (options.size) {
                s = 'size=' + options.size.toString() + '&';
            }
            if (options.notPaged) {
                s += 'notPaged=true&';
            }
            if (options.params) {
                options.params.forEach((/**
                 * @param {?} param
                 * @return {?}
                 */
                function (param) {
                    s += param.key + '=' + param.value + '&';
                }));
            }
            if (options.sort) {
                options.sort.forEach((/**
                 * @param {?} sortInfo
                 * @return {?}
                 */
                function (sortInfo) {
                    /** @type {?} */
                    var sortString = '';
                    sortString = sortInfo.path ? sortString.concat(sortInfo.path) : sortString;
                    sortString = sortInfo.order ? sortString.concat(',').concat(sortInfo.order) : sortString;
                    s += 'sort' + sortString + '&';
                }));
            }
            return s;
        };
        CacheHelper.isActive = true;
        // TODO
        CacheHelper.maxEntries = 100;
        CacheHelper.evictStrategy = EvictStrategy.EvictTrivial;
        CacheHelper.defaultExpire = 10 * 60 * 1000; // 10 minutes
        // 10 minutes
        CacheHelper.cacheMap = new Map();
        return CacheHelper;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ExternalService = /** @class */ (function () {
        function ExternalService(externalConfigurationService) {
            this.externalConfigurationService = externalConfigurationService;
            ResourceHelper.setProxyUri(externalConfigurationService.getProxyUri());
            ResourceHelper.setRootUri(externalConfigurationService.getRootUri());
            ResourceHelper.setHttp(externalConfigurationService.getHttp());
            CacheHelper.initClearCacheProcess();
        }
        /**
         * @param {?} externalConfigurationService
         * @return {?}
         */
        ExternalService.prototype.updateExternalConfigurationHandlerInterface = /**
         * @param {?} externalConfigurationService
         * @return {?}
         */
        function (externalConfigurationService) {
            this.externalConfigurationService = externalConfigurationService;
            ResourceHelper.setProxyUri(externalConfigurationService.getProxyUri());
            ResourceHelper.setRootUri(externalConfigurationService.getRootUri());
            ResourceHelper.setHttp(externalConfigurationService.getHttp());
        };
        /**
         * @return {?}
         */
        ExternalService.prototype.getExternalConfiguration = /**
         * @return {?}
         */
        function () {
            return this.externalConfigurationService.getExternalConfiguration();
        };
        /**
         * @return {?}
         */
        ExternalService.prototype.getProxyUri = /**
         * @return {?}
         */
        function () {
            return this.externalConfigurationService.getProxyUri();
        };
        /**
         * @return {?}
         */
        ExternalService.prototype.getRootUri = /**
         * @return {?}
         */
        function () {
            return this.externalConfigurationService.getRootUri();
        };
        /**
         * @return {?}
         */
        ExternalService.prototype.getURL = /**
         * @return {?}
         */
        function () {
            return ResourceHelper.getURL();
        };
        /**
         * @return {?}
         */
        ExternalService.prototype.getHttp = /**
         * @return {?}
         */
        function () {
            return ResourceHelper.getHttp();
        };
        ExternalService.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        ExternalService.ctorParameters = function () { return [
            { type: undefined, decorators: [{ type: core.Inject, args: ['ExternalConfigurationService',] }] }
        ]; };
        return ExternalService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var CustomEncoder = /** @class */ (function () {
        function CustomEncoder() {
        }
        /**
         * @param {?} key
         * @return {?}
         */
        CustomEncoder.prototype.encodeKey = /**
         * @param {?} key
         * @return {?}
         */
        function (key) {
            return encodeURIComponent(key);
        };
        /**
         * @param {?} value
         * @return {?}
         */
        CustomEncoder.prototype.encodeValue = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            return encodeURIComponent(value);
        };
        /**
         * @param {?} key
         * @return {?}
         */
        CustomEncoder.prototype.decodeKey = /**
         * @param {?} key
         * @return {?}
         */
        function (key) {
            return decodeURIComponent(key);
        };
        /**
         * @param {?} value
         * @return {?}
         */
        CustomEncoder.prototype.decodeValue = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            return decodeURIComponent(value);
        };
        return CustomEncoder;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ResourceService = /** @class */ (function () {
        function ResourceService(externalService) {
            this.externalService = externalService;
        }
        /**
         * @private
         * @return {?}
         */
        ResourceService.getURL = /**
         * @private
         * @return {?}
         */
        function () {
            return ResourceHelper.getURL();
        };
        /**
         * @template T
         * @param {?} type
         * @param {?} resource
         * @param {?} _embedded
         * @param {?=} options
         * @param {?=} subType
         * @return {?}
         */
        ResourceService.prototype.getAll = /**
         * @template T
         * @param {?} type
         * @param {?} resource
         * @param {?} _embedded
         * @param {?=} options
         * @param {?=} subType
         * @return {?}
         */
        function (type, resource, _embedded, options, subType) {
            /** @type {?} */
            var uri = this.getResourceUrl(resource);
            /** @type {?} */
            var params = ResourceHelper.optionParams(new http.HttpParams({ encoder: new CustomEncoder() }), options);
            /** @type {?} */
            var result = ResourceHelper.createEmptyResult(_embedded);
            this.setUrls(result);
            result.sortInfo = options ? options.sort : undefined;
            /** @type {?} */
            var observable = ResourceHelper.getHttp().get(uri, {
                headers: ResourceHelper.headers,
                observe: 'response',
                params: params
            });
            return observable.pipe(operators.map((/**
             * @param {?} response
             * @return {?}
             */
            function (response) { return ResourceHelper.instantiateResourceCollection(type, response, result, subType); })), operators.catchError((/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return rxjs.throwError(error); })));
        };
        /**
         * @template T
         * @param {?} type
         * @param {?} resource
         * @param {?} id
         * @param {?=} params
         * @param {?=} builder
         * @return {?}
         */
        ResourceService.prototype.get = /**
         * @template T
         * @param {?} type
         * @param {?} resource
         * @param {?} id
         * @param {?=} params
         * @param {?=} builder
         * @return {?}
         */
        function (type, resource, id, params, builder) {
            /** @type {?} */
            var uri = this.getResourceUrl(resource).concat('/', id);
            /** @type {?} */
            var result = new type();
            /** @type {?} */
            var httpParams = ResourceHelper.params(new http.HttpParams(), params);
            this.setUrlsResource(result);
            /** @type {?} */
            var observable = ResourceHelper.getHttp().get(uri, {
                headers: ResourceHelper.headers,
                observe: 'response',
                params: httpParams
            });
            return observable.pipe(operators.map((/**
             * @param {?} response
             * @return {?}
             */
            function (response) {
                if (builder) {
                    /** @type {?} */
                    var linkHref = url.parse(response.body._links.self.href).pathname;
                    /** @type {?} */
                    var regex = /([A-Za-z0-9]+)\/([A-Za-z0-9]+)\/([A-Za-z0-9]+)/g;
                    /** @type {?} */
                    var match = regex.exec(linkHref);
                    if (match != null) {
                        /** @type {?} */
                        var embeddedClassName = match[2];
                        result = ResourceHelper.searchSubtypes(builder, embeddedClassName, result);
                    }
                }
                return ResourceHelper.instantiateResourceFromResponse(result, response);
            })), operators.catchError((/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return rxjs.throwError(error); })));
        };
        /**
         * @template T
         * @param {?} type
         * @param {?} resourceLink
         * @return {?}
         */
        ResourceService.prototype.getBySelfLink = /**
         * @template T
         * @param {?} type
         * @param {?} resourceLink
         * @return {?}
         */
        function (type, resourceLink) {
            /** @type {?} */
            var result = new type();
            this.setUrlsResource(result);
            /** @type {?} */
            var observable = ResourceHelper.getHttp().get(ResourceHelper.getProxy(resourceLink), { headers: ResourceHelper.headers });
            return observable.pipe(operators.map((/**
             * @param {?} data
             * @return {?}
             */
            function (data) { return ResourceHelper.instantiateResource(result, data); })), operators.catchError((/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return rxjs.throwError(error); })));
        };
        /**
         * @template T
         * @param {?} type
         * @param {?} query
         * @param {?} resource
         * @param {?} _embedded
         * @param {?=} options
         * @param {?=} subType
         * @return {?}
         */
        ResourceService.prototype.search = /**
         * @template T
         * @param {?} type
         * @param {?} query
         * @param {?} resource
         * @param {?} _embedded
         * @param {?=} options
         * @param {?=} subType
         * @return {?}
         */
        function (type, query, resource, _embedded, options, subType) {
            /** @type {?} */
            var uri = this.getResourceUrl(resource).concat('/search/', query);
            /** @type {?} */
            var params = ResourceHelper.optionParams(new http.HttpParams({ encoder: new CustomEncoder() }), options);
            /** @type {?} */
            var result = ResourceHelper.createEmptyResult(_embedded);
            this.setUrls(result);
            /** @type {?} */
            var observable = ResourceHelper.getHttp().get(uri, {
                headers: ResourceHelper.headers,
                observe: 'response',
                params: params
            });
            return observable.pipe(operators.map((/**
             * @param {?} response
             * @return {?}
             */
            function (response) { return ResourceHelper.instantiateResourceCollection(type, response, result, subType); })), operators.catchError((/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return rxjs.throwError(error); })));
        };
        /**
         * @template T
         * @param {?} type
         * @param {?} query
         * @param {?} resource
         * @param {?=} options
         * @return {?}
         */
        ResourceService.prototype.searchSingle = /**
         * @template T
         * @param {?} type
         * @param {?} query
         * @param {?} resource
         * @param {?=} options
         * @return {?}
         */
        function (type, query, resource, options) {
            /** @type {?} */
            var uri = this.getResourceUrl(resource).concat('/search/', query);
            /** @type {?} */
            var params = ResourceHelper.optionParams(new http.HttpParams({ encoder: new CustomEncoder() }), options);
            /** @type {?} */
            var result = new type();
            this.setUrlsResource(result);
            /** @type {?} */
            var observable = ResourceHelper.getHttp().get(uri, { headers: ResourceHelper.headers, params: params });
            return observable.pipe(operators.map((/**
             * @param {?} response
             * @return {?}
             */
            function (response) { return ResourceHelper.instantiateResource(result, response); })), operators.catchError((/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return rxjs.throwError(error); })));
        };
        /**
         * @template T
         * @param {?} type
         * @param {?} query
         * @param {?} resource
         * @param {?} _embedded
         * @param {?=} options
         * @param {?=} subType
         * @return {?}
         */
        ResourceService.prototype.customQuery = /**
         * @template T
         * @param {?} type
         * @param {?} query
         * @param {?} resource
         * @param {?} _embedded
         * @param {?=} options
         * @param {?=} subType
         * @return {?}
         */
        function (type, query, resource, _embedded, options, subType) {
            /** @type {?} */
            var uri = this.getResourceUrl(resource + query);
            /** @type {?} */
            var params = ResourceHelper.optionParams(new http.HttpParams({ encoder: new CustomEncoder() }), options);
            /** @type {?} */
            var result = ResourceHelper.createEmptyResult(_embedded);
            this.setUrls(result);
            /** @type {?} */
            var observable = ResourceHelper.getHttp().get(uri, {
                headers: ResourceHelper.headers,
                observe: 'response',
                params: params
            });
            return observable.pipe(operators.map((/**
             * @param {?} response
             * @return {?}
             */
            function (response) { return ResourceHelper.instantiateResourceCollection(type, response, result, subType); })), operators.catchError((/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return rxjs.throwError(error); })));
        };
        /**
         * @template T
         * @param {?} type
         * @param {?} query
         * @param {?} resource
         * @param {?} _embedded
         * @param {?=} options
         * @param {?=} body
         * @param {?=} subType
         * @return {?}
         */
        ResourceService.prototype.customQueryPost = /**
         * @template T
         * @param {?} type
         * @param {?} query
         * @param {?} resource
         * @param {?} _embedded
         * @param {?=} options
         * @param {?=} body
         * @param {?=} subType
         * @return {?}
         */
        function (type, query, resource, _embedded, options, body, subType) {
            /** @type {?} */
            var uri = this.getResourceUrl(resource + query);
            /** @type {?} */
            var params = ResourceHelper.optionParams(new http.HttpParams(), options);
            /** @type {?} */
            var result = ResourceHelper.createEmptyResult(_embedded);
            this.setUrls(result);
            /** @type {?} */
            var observable = ResourceHelper.getHttp().post(uri, body, {
                headers: ResourceHelper.headers,
                observe: 'response',
                params: params
            });
            return observable.pipe(operators.map((/**
             * @param {?} response
             * @return {?}
             */
            function (response) { return ResourceHelper.instantiateResourceCollection(type, response, result, subType); })), operators.catchError((/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return rxjs.throwError(error); })));
        };
        /**
         * @template T
         * @param {?} type
         * @param {?} resourceLink
         * @return {?}
         */
        ResourceService.prototype.getByRelation = /**
         * @template T
         * @param {?} type
         * @param {?} resourceLink
         * @return {?}
         */
        function (type, resourceLink) {
            /** @type {?} */
            var result = new type();
            this.setUrlsResource(result);
            /** @type {?} */
            var observable = ResourceHelper.getHttp().get(resourceLink, { headers: ResourceHelper.headers });
            return observable.pipe(operators.map((/**
             * @param {?} data
             * @return {?}
             */
            function (data) { return ResourceHelper.instantiateResource(result, data); })), operators.catchError((/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return rxjs.throwError(error); })));
        };
        /**
         * @template T
         * @param {?} type
         * @param {?} resourceLink
         * @param {?} _embedded
         * @param {?=} builder
         * @return {?}
         */
        ResourceService.prototype.getByRelationArray = /**
         * @template T
         * @param {?} type
         * @param {?} resourceLink
         * @param {?} _embedded
         * @param {?=} builder
         * @return {?}
         */
        function (type, resourceLink, _embedded, builder) {
            /** @type {?} */
            var result = ResourceHelper.createEmptyResult(_embedded);
            this.setUrls(result);
            /** @type {?} */
            var observable = ResourceHelper.getHttp().get(resourceLink, {
                headers: ResourceHelper.headers,
                observe: 'response'
            });
            return observable.pipe(operators.map((/**
             * @param {?} response
             * @return {?}
             */
            function (response) { return ResourceHelper.instantiateResourceCollection(type, response, result, builder); })), operators.catchError((/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return rxjs.throwError(error); })));
        };
        /**
         * @template T
         * @param {?} type
         * @param {?} resource
         * @param {?} id
         * @param {?} projectionName
         * @return {?}
         */
        ResourceService.prototype.getProjection = /**
         * @template T
         * @param {?} type
         * @param {?} resource
         * @param {?} id
         * @param {?} projectionName
         * @return {?}
         */
        function (type, resource, id, projectionName) {
            /** @type {?} */
            var uri = this.getResourceUrl(resource).concat('/', id).concat('?projection=' + projectionName);
            /** @type {?} */
            var result = new type();
            /** @type {?} */
            var observable = ResourceHelper.getHttp().get(uri, { headers: ResourceHelper.headers });
            return observable.pipe(operators.map((/**
             * @param {?} data
             * @return {?}
             */
            function (data) { return ResourceHelper.instantiateResource(result, data); })), operators.catchError((/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return rxjs.throwError(error); })));
        };
        /**
         * @template T
         * @param {?} type
         * @param {?} resource
         * @param {?} projectionName
         * @return {?}
         */
        ResourceService.prototype.getProjectionArray = /**
         * @template T
         * @param {?} type
         * @param {?} resource
         * @param {?} projectionName
         * @return {?}
         */
        function (type, resource, projectionName) {
            /** @type {?} */
            var uri = this.getResourceUrl(resource).concat('?projection=' + projectionName);
            /** @type {?} */
            var result = ResourceHelper.createEmptyResult('_embedded');
            /** @type {?} */
            var observable = ResourceHelper.getHttp().get(uri, {
                headers: ResourceHelper.headers,
                observe: 'response'
            });
            return observable
                .pipe(operators.map((/**
             * @param {?} response
             * @return {?}
             */
            function (response) { return ResourceHelper.instantiateResourceCollection(type, response, result); })), operators.catchError((/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return rxjs.throwError(error); }))).pipe(operators.map((/**
             * @param {?} resourceArray
             * @return {?}
             */
            function (resourceArray) {
                return resourceArray.result;
            })));
        };
        /**
         * @param {?} resource
         * @param {?=} query
         * @param {?=} options
         * @return {?}
         */
        ResourceService.prototype.count = /**
         * @param {?} resource
         * @param {?=} query
         * @param {?=} options
         * @return {?}
         */
        function (resource, query, options) {
            /** @type {?} */
            var uri = this.getResourceUrl(resource).concat('/search/' + (query === undefined ? 'countAll' : query));
            /** @type {?} */
            var params = ResourceHelper.optionParams(new http.HttpParams(), options);
            return ResourceHelper.getHttp().get(uri, {
                headers: ResourceHelper.headers,
                observe: 'response',
                params: params
            }).pipe(operators.map((/**
             * @param {?} response
             * @return {?}
             */
            function (response) { return Number(response.body); })), operators.catchError((/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return rxjs.throwError(error); })));
        };
        /**
         * @template T
         * @param {?} selfResource
         * @param {?} entity
         * @return {?}
         */
        ResourceService.prototype.create = /**
         * @template T
         * @param {?} selfResource
         * @param {?} entity
         * @return {?}
         */
        function (selfResource, entity) {
            /** @type {?} */
            var uri = ResourceHelper.getURL() + selfResource;
            /** @type {?} */
            var payload = ResourceHelper.resolveRelations(entity);
            this.setUrlsResource(entity);
            /** @type {?} */
            var observable = ResourceHelper.getHttp().post(uri, payload, {
                headers: ResourceHelper.headers,
                observe: 'response'
            });
            return observable.pipe(operators.map((/**
             * @param {?} response
             * @return {?}
             */
            function (response) {
                if (response.status >= 200 && response.status <= 207) {
                    return ResourceHelper.instantiateResource(entity, response.body);
                }
                else if (response.status === 500) {
                    /** @type {?} */
                    var body = response.body;
                    return rxjs.throwError(body.error);
                }
            })), operators.catchError((/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return rxjs.throwError(error); })));
        };
        /**
         * @template T
         * @param {?} entity
         * @return {?}
         */
        ResourceService.prototype.update = /**
         * @template T
         * @param {?} entity
         * @return {?}
         */
        function (entity) {
            /** @type {?} */
            var uri = ResourceHelper.getProxy(entity._links.self.href);
            /** @type {?} */
            var payload = ResourceHelper.resolveRelations(entity);
            this.setUrlsResource(entity);
            /** @type {?} */
            var observable = ResourceHelper.getHttp().put(uri, payload, {
                headers: ResourceHelper.headers,
                observe: 'response'
            });
            return observable.pipe(operators.map((/**
             * @param {?} response
             * @return {?}
             */
            function (response) {
                if (response.status >= 200 && response.status <= 207) {
                    return ResourceHelper.instantiateResource(entity, response.body);
                }
                else if (response.status === 500) {
                    /** @type {?} */
                    var body = response.body;
                    return rxjs.throwError(body.error);
                }
            })), operators.catchError((/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return rxjs.throwError(error); })));
        };
        /**
         * @template T
         * @param {?} entity
         * @return {?}
         */
        ResourceService.prototype.patch = /**
         * @template T
         * @param {?} entity
         * @return {?}
         */
        function (entity) {
            /** @type {?} */
            var uri = ResourceHelper.getProxy(entity._links.self.href);
            /** @type {?} */
            var payload = ResourceHelper.resolveRelations(entity);
            this.setUrlsResource(entity);
            /** @type {?} */
            var observable = ResourceHelper.getHttp().patch(uri, payload, {
                headers: ResourceHelper.headers,
                observe: 'response'
            });
            return observable.pipe(operators.map((/**
             * @param {?} response
             * @return {?}
             */
            function (response) {
                if (response.status >= 200 && response.status <= 207) {
                    return ResourceHelper.instantiateResource(entity, response.body);
                }
                else if (response.status === 500) {
                    /** @type {?} */
                    var body = response.body;
                    return rxjs.throwError(body.error);
                }
            })), operators.catchError((/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return rxjs.throwError(error); })));
        };
        /**
         * @template T
         * @param {?} entity
         * @return {?}
         */
        ResourceService.prototype.delete = /**
         * @template T
         * @param {?} entity
         * @return {?}
         */
        function (entity) {
            /** @type {?} */
            var uri = ResourceHelper.getProxy(entity._links.self.href);
            return ResourceHelper.getHttp().delete(uri, { headers: ResourceHelper.headers }).pipe(operators.catchError((/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return rxjs.throwError(error); })));
        };
        /**
         * @template T
         * @param {?} resourceArray
         * @return {?}
         */
        ResourceService.prototype.hasNext = /**
         * @template T
         * @param {?} resourceArray
         * @return {?}
         */
        function (resourceArray) {
            return resourceArray.next_uri !== undefined;
        };
        /**
         * @template T
         * @param {?} resourceArray
         * @return {?}
         */
        ResourceService.prototype.hasPrev = /**
         * @template T
         * @param {?} resourceArray
         * @return {?}
         */
        function (resourceArray) {
            return resourceArray.prev_uri !== undefined;
        };
        /**
         * @template T
         * @param {?} resourceArray
         * @return {?}
         */
        ResourceService.prototype.hasFirst = /**
         * @template T
         * @param {?} resourceArray
         * @return {?}
         */
        function (resourceArray) {
            return resourceArray.first_uri !== undefined;
        };
        /**
         * @template T
         * @param {?} resourceArray
         * @return {?}
         */
        ResourceService.prototype.hasLast = /**
         * @template T
         * @param {?} resourceArray
         * @return {?}
         */
        function (resourceArray) {
            return resourceArray.last_uri !== undefined;
        };
        /**
         * @template T
         * @param {?} resourceArray
         * @param {?} type
         * @return {?}
         */
        ResourceService.prototype.next = /**
         * @template T
         * @param {?} resourceArray
         * @param {?} type
         * @return {?}
         */
        function (resourceArray, type) {
            return resourceArray.next(type);
        };
        /**
         * @template T
         * @param {?} resourceArray
         * @param {?} type
         * @return {?}
         */
        ResourceService.prototype.prev = /**
         * @template T
         * @param {?} resourceArray
         * @param {?} type
         * @return {?}
         */
        function (resourceArray, type) {
            return resourceArray.prev(type);
        };
        /**
         * @template T
         * @param {?} resourceArray
         * @param {?} type
         * @return {?}
         */
        ResourceService.prototype.first = /**
         * @template T
         * @param {?} resourceArray
         * @param {?} type
         * @return {?}
         */
        function (resourceArray, type) {
            return resourceArray.first(type);
        };
        /**
         * @template T
         * @param {?} resourceArray
         * @param {?} type
         * @return {?}
         */
        ResourceService.prototype.last = /**
         * @template T
         * @param {?} resourceArray
         * @param {?} type
         * @return {?}
         */
        function (resourceArray, type) {
            return resourceArray.last(type);
        };
        /**
         * @template T
         * @param {?} resourceArray
         * @param {?} type
         * @param {?} id
         * @return {?}
         */
        ResourceService.prototype.page = /**
         * @template T
         * @param {?} resourceArray
         * @param {?} type
         * @param {?} id
         * @return {?}
         */
        function (resourceArray, type, id) {
            return resourceArray.page(type, id);
        };
        /**
         * @template T
         * @param {?} resourceArray
         * @param {?} type
         * @param {...?} sort
         * @return {?}
         */
        ResourceService.prototype.sortElements = /**
         * @template T
         * @param {?} resourceArray
         * @param {?} type
         * @param {...?} sort
         * @return {?}
         */
        function (resourceArray, type) {
            var sort = [];
            for (var _i = 2; _i < arguments.length; _i++) {
                sort[_i - 2] = arguments[_i];
            }
            return resourceArray.sortElements.apply(resourceArray, __spread([type], sort));
        };
        /**
         * @template T
         * @param {?} resourceArray
         * @param {?} type
         * @param {?} size
         * @return {?}
         */
        ResourceService.prototype.size = /**
         * @template T
         * @param {?} resourceArray
         * @param {?} type
         * @param {?} size
         * @return {?}
         */
        function (resourceArray, type, size) {
            return resourceArray.size(type, size);
        };
        /**
         * @private
         * @param {?=} resource
         * @return {?}
         */
        ResourceService.prototype.getResourceUrl = /**
         * @private
         * @param {?=} resource
         * @return {?}
         */
        function (resource) {
            /** @type {?} */
            var resourceUrl = ResourceService.getURL();
            if (!resourceUrl.endsWith('/')) {
                resourceUrl = resourceUrl.concat('/');
            }
            if (resource) {
                return resourceUrl.concat(resource);
            }
            resourceUrl = resourceUrl.replace('{?projection}', '');
            return resourceUrl;
        };
        /**
         * @private
         * @template T
         * @param {?} result
         * @return {?}
         */
        ResourceService.prototype.setUrls = /**
         * @private
         * @template T
         * @param {?} result
         * @return {?}
         */
        function (result) {
            result.proxyUrl = this.externalService.getProxyUri();
            result.rootUrl = this.externalService.getRootUri();
        };
        /**
         * @private
         * @template T
         * @param {?} result
         * @return {?}
         */
        ResourceService.prototype.setUrlsResource = /**
         * @private
         * @template T
         * @param {?} result
         * @return {?}
         */
        function (result) {
            result.proxyUrl = this.externalService.getProxyUri();
            result.rootUrl = this.externalService.getRootUri();
        };
        ResourceService.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        ResourceService.ctorParameters = function () { return [
            { type: ExternalService }
        ]; };
        return ResourceService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @template T
     */
    var   /**
     * @template T
     */
    RestService = /** @class */ (function () {
        function RestService(type, resource, injector, _embedded) {
            this.injector = injector;
            this._embedded = '_embedded';
            this.type = type;
            this.resource = resource;
            this.resourceService = injector.get(ResourceService);
            if (!Utils.isNullOrUndefined(_embedded)) {
                this._embedded = _embedded;
            }
        }
        /**
         * @protected
         * @param {?} error
         * @return {?}
         */
        RestService.handleError = /**
         * @protected
         * @param {?} error
         * @return {?}
         */
        function (error) {
            return rxjs.throwError(error);
        };
        /**
         * @param {?=} options
         * @param {?=} subType
         * @return {?}
         */
        RestService.prototype.getAll = /**
         * @param {?=} options
         * @param {?=} subType
         * @return {?}
         */
        function (options, subType) {
            var _this = this;
            return this.resourceService.getAll(this.type, this.resource, this._embedded, options, subType).pipe(operators.mergeMap((/**
             * @param {?} resourceArray
             * @return {?}
             */
            function (resourceArray) {
                if (options && options.notPaged && !Utils.isNullOrUndefined(resourceArray.first_uri)) {
                    options.notPaged = false;
                    options.size = resourceArray.totalElements;
                    return _this.getAll(options);
                }
                else {
                    _this.resourceArray = resourceArray;
                    return rxjs.of(resourceArray.result);
                }
            })));
        };
        /**
         * @param {?} id
         * @param {?=} params
         * @param {?=} builder
         * @return {?}
         */
        RestService.prototype.get = /**
         * @param {?} id
         * @param {?=} params
         * @param {?=} builder
         * @return {?}
         */
        function (id, params, builder) {
            return this.resourceService.get(this.type, this.resource, id, params, builder);
        };
        /**
         * @param {?} selfLink
         * @return {?}
         */
        RestService.prototype.getBySelfLink = /**
         * @param {?} selfLink
         * @return {?}
         */
        function (selfLink) {
            return this.resourceService.getBySelfLink(this.type, selfLink);
        };
        /**
         * @param {?} query
         * @param {?=} options
         * @param {?=} subType
         * @return {?}
         */
        RestService.prototype.search = /**
         * @param {?} query
         * @param {?=} options
         * @param {?=} subType
         * @return {?}
         */
        function (query, options, subType) {
            var _this = this;
            return this.resourceService.search(this.type, query, this.resource, this._embedded, options, subType).pipe(operators.mergeMap((/**
             * @param {?} resourceArray
             * @return {?}
             */
            function (resourceArray) {
                if (options && options.notPaged && !Utils.isNullOrUndefined(resourceArray.first_uri)) {
                    options.notPaged = false;
                    options.size = resourceArray.totalElements;
                    return _this.search(query, options, subType);
                }
                else {
                    _this.resourceArray = resourceArray;
                    return rxjs.of(resourceArray.result);
                }
            })));
        };
        /**
         * @param {?} query
         * @param {?=} options
         * @return {?}
         */
        RestService.prototype.searchSingle = /**
         * @param {?} query
         * @param {?=} options
         * @return {?}
         */
        function (query, options) {
            return this.resourceService.searchSingle(this.type, query, this.resource, options);
        };
        /**
         * @param {?} query
         * @param {?=} options
         * @param {?=} subType
         * @return {?}
         */
        RestService.prototype.customQuery = /**
         * @param {?} query
         * @param {?=} options
         * @param {?=} subType
         * @return {?}
         */
        function (query, options, subType) {
            var _this = this;
            return this.resourceService.customQuery(this.type, query, this.resource, this._embedded, options, subType).pipe(operators.mergeMap((/**
             * @param {?} resourceArray
             * @return {?}
             */
            function (resourceArray) {
                if (options && options.notPaged && !Utils.isNullOrUndefined(resourceArray.first_uri)) {
                    options.notPaged = false;
                    options.size = resourceArray.totalElements;
                    return _this.customQuery(query, options, subType);
                }
                else {
                    _this.resourceArray = resourceArray;
                    return rxjs.of(resourceArray.result);
                }
            })));
        };
        /**
         * @param {?} query
         * @param {?=} options
         * @param {?=} body
         * @param {?=} subType
         * @return {?}
         */
        RestService.prototype.customQueryPost = /**
         * @param {?} query
         * @param {?=} options
         * @param {?=} body
         * @param {?=} subType
         * @return {?}
         */
        function (query, options, body, subType) {
            var _this = this;
            return this.resourceService.customQueryPost(this.type, query, this.resource, this._embedded, options, body, subType).pipe(operators.mergeMap((/**
             * @param {?} resourceArray
             * @return {?}
             */
            function (resourceArray) {
                if (options && options.notPaged && !Utils.isNullOrUndefined(resourceArray.first_uri)) {
                    options.notPaged = false;
                    options.size = resourceArray.totalElements;
                    return _this.customQueryPost(query, options, body, subType);
                }
                else {
                    _this.resourceArray = resourceArray;
                    return rxjs.of(resourceArray.result);
                }
            })));
        };
        /**
         * @param {?} relation
         * @param {?=} builder
         * @return {?}
         */
        RestService.prototype.getByRelationArray = /**
         * @param {?} relation
         * @param {?=} builder
         * @return {?}
         */
        function (relation, builder) {
            var _this = this;
            return this.resourceService.getByRelationArray(this.type, relation, this._embedded, builder).pipe(operators.map((/**
             * @param {?} resourceArray
             * @return {?}
             */
            function (resourceArray) {
                _this.resourceArray = resourceArray;
                return resourceArray.result;
            })));
        };
        /**
         * @param {?} relation
         * @return {?}
         */
        RestService.prototype.getByRelation = /**
         * @param {?} relation
         * @return {?}
         */
        function (relation) {
            return this.resourceService.getByRelation(this.type, relation);
        };
        /**
         * @param {?=} query
         * @param {?=} options
         * @return {?}
         */
        RestService.prototype.count = /**
         * @param {?=} query
         * @param {?=} options
         * @return {?}
         */
        function (query, options) {
            return this.resourceService.count(this.resource, query, options);
        };
        /**
         * @param {?} entity
         * @return {?}
         */
        RestService.prototype.create = /**
         * @param {?} entity
         * @return {?}
         */
        function (entity) {
            return this.resourceService.create(this.resource, entity);
        };
        /**
         * @param {?} entity
         * @return {?}
         */
        RestService.prototype.update = /**
         * @param {?} entity
         * @return {?}
         */
        function (entity) {
            return this.resourceService.update(entity);
        };
        /**
         * @param {?} entity
         * @return {?}
         */
        RestService.prototype.patch = /**
         * @param {?} entity
         * @return {?}
         */
        function (entity) {
            return this.resourceService.patch(entity);
        };
        /**
         * @param {?} entity
         * @return {?}
         */
        RestService.prototype.delete = /**
         * @param {?} entity
         * @return {?}
         */
        function (entity) {
            return this.resourceService.delete(entity);
        };
        /**
         * @return {?}
         */
        RestService.prototype.totalElement = /**
         * @return {?}
         */
        function () {
            if (this.resourceArray && this.resourceArray.totalElements) {
                return this.resourceArray.totalElements;
            }
            return 0;
        };
        /**
         * @return {?}
         */
        RestService.prototype.totalPages = /**
         * @return {?}
         */
        function () {
            if (this.resourceArray && this.resourceArray.totalPages) {
                return this.resourceArray.totalPages;
            }
            return 1;
        };
        /**
         * @return {?}
         */
        RestService.prototype.hasFirst = /**
         * @return {?}
         */
        function () {
            if (this.resourceArray) {
                return this.resourceService.hasFirst(this.resourceArray);
            }
            return false;
        };
        /**
         * @return {?}
         */
        RestService.prototype.hasNext = /**
         * @return {?}
         */
        function () {
            if (this.resourceArray) {
                return this.resourceService.hasNext(this.resourceArray);
            }
            return false;
        };
        /**
         * @return {?}
         */
        RestService.prototype.hasPrev = /**
         * @return {?}
         */
        function () {
            if (this.resourceArray) {
                return this.resourceService.hasPrev(this.resourceArray);
            }
            return false;
        };
        /**
         * @return {?}
         */
        RestService.prototype.hasLast = /**
         * @return {?}
         */
        function () {
            if (this.resourceArray) {
                return this.resourceService.hasLast(this.resourceArray);
            }
            return false;
        };
        /**
         * @return {?}
         */
        RestService.prototype.next = /**
         * @return {?}
         */
        function () {
            var _this = this;
            if (this.resourceArray) {
                return this.resourceService.next(this.resourceArray, this.type).pipe(operators.map((/**
                 * @param {?} resourceArray
                 * @return {?}
                 */
                function (resourceArray) {
                    _this.resourceArray = resourceArray;
                    return resourceArray.result;
                })));
            }
            else {
                return rxjs.throwError('no resourceArray found');
            }
        };
        /**
         * @return {?}
         */
        RestService.prototype.prev = /**
         * @return {?}
         */
        function () {
            var _this = this;
            if (this.resourceArray) {
                return this.resourceService.prev(this.resourceArray, this.type).pipe(operators.map((/**
                 * @param {?} resourceArray
                 * @return {?}
                 */
                function (resourceArray) {
                    _this.resourceArray = resourceArray;
                    return resourceArray.result;
                })));
            }
            else {
                return rxjs.throwError('no resourceArray found');
            }
        };
        /**
         * @return {?}
         */
        RestService.prototype.first = /**
         * @return {?}
         */
        function () {
            var _this = this;
            if (this.resourceArray) {
                return this.resourceService.first(this.resourceArray, this.type)
                    .pipe(operators.map((/**
                 * @param {?} resourceArray
                 * @return {?}
                 */
                function (resourceArray) {
                    _this.resourceArray = resourceArray;
                    return resourceArray.result;
                })));
            }
            else {
                return rxjs.throwError('no resourceArray found');
            }
        };
        /**
         * @return {?}
         */
        RestService.prototype.last = /**
         * @return {?}
         */
        function () {
            var _this = this;
            if (this.resourceArray) {
                return this.resourceService.last(this.resourceArray, this.type)
                    .pipe(operators.map((/**
                 * @param {?} resourceArray
                 * @return {?}
                 */
                function (resourceArray) {
                    _this.resourceArray = resourceArray;
                    return resourceArray.result;
                })));
            }
            else {
                return rxjs.throwError('no resourceArray found');
            }
        };
        /**
         * @param {?} pageNumber
         * @return {?}
         */
        RestService.prototype.page = /**
         * @param {?} pageNumber
         * @return {?}
         */
        function (pageNumber) {
            var _this = this;
            if (this.resourceArray) {
                return this.resourceService.page(this.resourceArray, this.type, pageNumber).pipe(operators.map((/**
                 * @param {?} resourceArray
                 * @return {?}
                 */
                function (resourceArray) {
                    _this.resourceArray = resourceArray;
                    return resourceArray.result;
                })));
            }
            else {
                return rxjs.throwError('no resourceArray found');
            }
        };
        /**
         * @protected
         * @param {?} error
         * @return {?}
         */
        RestService.prototype.handleError = /**
         * @protected
         * @param {?} error
         * @return {?}
         */
        function (error) {
            return RestService.handleError(error);
        };
        return RestService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @abstract
     */
    var Resource = /** @class */ (function () {
        function Resource() {
        }
        Object.defineProperty(Resource.prototype, "subtypes", {
            get: /**
             * @return {?}
             */
            function () {
                return this._subtypes;
            },
            set: /**
             * @param {?} _subtypes
             * @return {?}
             */
            function (_subtypes) {
                this._subtypes = _subtypes;
            },
            enumerable: true,
            configurable: true
        });
        // Get related resource
        // Get related resource
        /**
         * @template T
         * @param {?} type
         * @param {?} relation
         * @param {?=} builder
         * @param {?=} expireMs
         * @param {?=} isCacheActive
         * @return {?}
         */
        Resource.prototype.getRelation = 
        // Get related resource
        /**
         * @template T
         * @param {?} type
         * @param {?} relation
         * @param {?=} builder
         * @param {?=} expireMs
         * @param {?=} isCacheActive
         * @return {?}
         */
        function (type, relation, builder, expireMs, isCacheActive) {
            var _this = this;
            if (expireMs === void 0) { expireMs = CacheHelper.defaultExpire; }
            if (isCacheActive === void 0) { isCacheActive = true; }
            /** @type {?} */
            var result = new type();
            if (this.existRelationLink(relation)) {
                if (CacheHelper.ifPresent(this.getRelationLinkHref(relation), null, null, isCacheActive)) {
                    return rxjs.of(CacheHelper.get(this.getRelationLinkHref(relation)));
                }
                /** @type {?} */
                var observable = ResourceHelper.getHttp().get(ResourceHelper.getProxy(this.getRelationLinkHref(relation)), { headers: ResourceHelper.headers });
                return observable.pipe(operators.map((/**
                 * @param {?} data
                 * @return {?}
                 */
                function (data) {
                    var e_1, _a;
                    if (builder) {
                        try {
                            for (var _b = __values(Object.keys(data._links)), _c = _b.next(); !_c.done; _c = _b.next()) {
                                var embeddedClassName = _c.value;
                                if (embeddedClassName === 'self') {
                                    /** @type {?} */
                                    var href = data._links[embeddedClassName].href;
                                    /** @type {?} */
                                    var idx = href.lastIndexOf('/');
                                    /** @type {?} */
                                    var realClassName = href.replace(ResourceHelper.getRootUri(), '').substring(0, idx);
                                    result = ResourceHelper.searchSubtypes(builder, realClassName, result);
                                    break;
                                }
                            }
                        }
                        catch (e_1_1) { e_1 = { error: e_1_1 }; }
                        finally {
                            try {
                                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                            }
                            finally { if (e_1) throw e_1.error; }
                        }
                    }
                    /** @type {?} */
                    var resource = ResourceHelper.instantiateResource(result, data);
                    CacheHelper.put(_this.getRelationLinkHref(relation), resource, expireMs);
                    return resource;
                })));
            }
            else {
                return rxjs.of(null);
            }
        };
        // Get collection of related resources
        // Get collection of related resources
        /**
         * @template T
         * @param {?} type
         * @param {?} relation
         * @param {?=} _embedded
         * @param {?=} options
         * @param {?=} builder
         * @param {?=} expireMs
         * @param {?=} isCacheActive
         * @return {?}
         */
        Resource.prototype.getRelationArray = 
        // Get collection of related resources
        /**
         * @template T
         * @param {?} type
         * @param {?} relation
         * @param {?=} _embedded
         * @param {?=} options
         * @param {?=} builder
         * @param {?=} expireMs
         * @param {?=} isCacheActive
         * @return {?}
         */
        function (type, relation, _embedded, options, builder, expireMs, isCacheActive) {
            var _this = this;
            if (expireMs === void 0) { expireMs = CacheHelper.defaultExpire; }
            if (isCacheActive === void 0) { isCacheActive = true; }
            /** @type {?} */
            var params = ResourceHelper.optionParams(new http.HttpParams({ encoder: new CustomEncoder() }), options);
            /** @type {?} */
            var result = ResourceHelper.createEmptyResult(Utils.isNullOrUndefined(_embedded) ? '_embedded' : _embedded);
            if (this.existRelationLink(relation)) {
                if (CacheHelper.ifPresent(this.getRelationLinkHref(relation), null, options, isCacheActive)) {
                    return rxjs.of(CacheHelper.getArray(this.getRelationLinkHref(relation)));
                }
                /** @type {?} */
                var observable = ResourceHelper.getHttp().get(ResourceHelper.getProxy(this.getRelationLinkHref(relation)), {
                    headers: ResourceHelper.headers, observe: 'response', params: params
                });
                return observable
                    .pipe(operators.map((/**
                 * @param {?} response
                 * @return {?}
                 */
                function (response) { return ResourceHelper.instantiateResourceCollection(type, response, result, builder); })), operators.catchError((/**
                 * @param {?} error
                 * @return {?}
                 */
                function (error) { return rxjs.throwError(error); }))).pipe(operators.map((/**
                 * @param {?} array
                 * @return {?}
                 */
                function (array) {
                    CacheHelper.putArray(_this.getRelationLinkHref(relation), array.result, expireMs);
                    return array.result;
                })));
            }
            else {
                return rxjs.of([]);
            }
        };
        /**
         * @template T
         * @param {?} type
         * @param {?} resource
         * @param {?} id
         * @param {?} projectionName
         * @param {?=} expireMs
         * @param {?=} isCacheActive
         * @return {?}
         */
        Resource.prototype.getProjection = /**
         * @template T
         * @param {?} type
         * @param {?} resource
         * @param {?} id
         * @param {?} projectionName
         * @param {?=} expireMs
         * @param {?=} isCacheActive
         * @return {?}
         */
        function (type, resource, id, projectionName, expireMs, isCacheActive) {
            if (expireMs === void 0) { expireMs = CacheHelper.defaultExpire; }
            if (isCacheActive === void 0) { isCacheActive = true; }
            /** @type {?} */
            var uri = this.getResourceUrl(resource).concat('/', id).concat('?projection=' + projectionName);
            /** @type {?} */
            var result = new type();
            if (CacheHelper.ifPresent(uri, null, null, isCacheActive)) {
                return rxjs.of(CacheHelper.get(uri));
            }
            /** @type {?} */
            var observable = ResourceHelper.getHttp().get(uri, { headers: ResourceHelper.headers });
            return observable.pipe(operators.map((/**
             * @param {?} data
             * @return {?}
             */
            function (data) {
                /** @type {?} */
                var resourceObject = ResourceHelper.instantiateResource(result, data);
                CacheHelper.put(uri, resourceObject, expireMs);
                return resourceObject;
            })), operators.catchError((/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return rxjs.throwError(error); })));
        };
        /**
         * @template T
         * @param {?} type
         * @param {?} resource
         * @param {?} projectionName
         * @param {?=} expireMs
         * @param {?=} isCacheActive
         * @return {?}
         */
        Resource.prototype.getProjectionArray = /**
         * @template T
         * @param {?} type
         * @param {?} resource
         * @param {?} projectionName
         * @param {?=} expireMs
         * @param {?=} isCacheActive
         * @return {?}
         */
        function (type, resource, projectionName, expireMs, isCacheActive) {
            if (expireMs === void 0) { expireMs = CacheHelper.defaultExpire; }
            if (isCacheActive === void 0) { isCacheActive = true; }
            /** @type {?} */
            var uri = this.getResourceUrl(resource).concat('?projection=' + projectionName);
            /** @type {?} */
            var result = ResourceHelper.createEmptyResult('_embedded');
            if (CacheHelper.ifPresent(uri, null, null, isCacheActive)) {
                return rxjs.of(CacheHelper.getArray(uri));
            }
            /** @type {?} */
            var observable = ResourceHelper.getHttp().get(uri, {
                headers: ResourceHelper.headers,
                observe: 'response'
            });
            return observable.pipe(operators.map((/**
             * @param {?} response
             * @return {?}
             */
            function (response) { return ResourceHelper.instantiateResourceCollection(type, response, result); })), operators.map((/**
             * @param {?} array
             * @return {?}
             */
            function (array) {
                CacheHelper.putArray(uri, array.result, expireMs);
                return array.result;
            })));
        };
        // Adds the given resource to the bound collection by the relation
        // Adds the given resource to the bound collection by the relation
        /**
         * @template T
         * @param {?} relation
         * @param {?} resource
         * @return {?}
         */
        Resource.prototype.addRelation = 
        // Adds the given resource to the bound collection by the relation
        /**
         * @template T
         * @param {?} relation
         * @param {?} resource
         * @return {?}
         */
        function (relation, resource) {
            if (this.existRelationLink(relation)) {
                /** @type {?} */
                var header = ResourceHelper.headers.append('Content-Type', 'text/uri-list');
                return ResourceHelper.getHttp().put(ResourceHelper.getProxy(this.getRelationLinkHref(relation)), resource._links.self.href, { headers: header });
            }
            else {
                return rxjs.throwError('no relation found');
            }
        };
        // Bind the given resource to this resource by the given relation
        // Bind the given resource to this resource by the given relation
        /**
         * @template T
         * @param {?} relation
         * @param {?} resource
         * @return {?}
         */
        Resource.prototype.updateRelation = 
        // Bind the given resource to this resource by the given relation
        /**
         * @template T
         * @param {?} relation
         * @param {?} resource
         * @return {?}
         */
        function (relation, resource) {
            if (this.existRelationLink(relation)) {
                /** @type {?} */
                var header = ResourceHelper.headers.append('Content-Type', 'text/uri-list');
                return ResourceHelper.getHttp().patch(ResourceHelper.getProxy(this.getRelationLinkHref(relation)), resource._links.self.href, { headers: header });
            }
            else {
                return rxjs.throwError('no relation found');
            }
        };
        // Bind the given resource to this resource by the given relation
        // Bind the given resource to this resource by the given relation
        /**
         * @template T
         * @param {?} relation
         * @param {?} resource
         * @return {?}
         */
        Resource.prototype.substituteRelation = 
        // Bind the given resource to this resource by the given relation
        /**
         * @template T
         * @param {?} relation
         * @param {?} resource
         * @return {?}
         */
        function (relation, resource) {
            if (this.existRelationLink(relation)) {
                /** @type {?} */
                var header = ResourceHelper.headers.append('Content-Type', 'text/uri-list');
                return ResourceHelper.getHttp().put(ResourceHelper.getProxy(this.getRelationLinkHref(relation)), resource._links.self.href, { headers: header });
            }
            else {
                return rxjs.throwError('no relation found');
            }
        };
        // Unbind the resource with the given relation from this resource
        // Unbind the resource with the given relation from this resource
        /**
         * @template T
         * @param {?} relation
         * @param {?} resource
         * @return {?}
         */
        Resource.prototype.deleteRelation = 
        // Unbind the resource with the given relation from this resource
        /**
         * @template T
         * @param {?} relation
         * @param {?} resource
         * @return {?}
         */
        function (relation, resource) {
            if (this.existRelationLink(relation)) {
                /** @type {?} */
                var link = resource._links.self.href;
                /** @type {?} */
                var idx = link.lastIndexOf('/') + 1;
                if (idx === -1) {
                    return rxjs.throwError('no relation found');
                }
                /** @type {?} */
                var relationId = link.substring(idx);
                return ResourceHelper.getHttp().delete(ResourceHelper.getProxy(this.getRelationLinkHref(relation) + '/' + relationId), { headers: ResourceHelper.headers });
            }
            else {
                return rxjs.throwError('no relation found');
            }
        };
        /**
         * @private
         * @param {?=} resource
         * @return {?}
         */
        Resource.prototype.getResourceUrl = /**
         * @private
         * @param {?=} resource
         * @return {?}
         */
        function (resource) {
            /** @type {?} */
            var url = ResourceHelper.getURL();
            if (!url.endsWith('/')) {
                url = url.concat('/');
            }
            if (resource) {
                return url.concat(resource);
            }
            url = url.replace('{?projection}', '');
            return url;
        };
        /**
         * @private
         * @param {?} relation
         * @return {?}
         */
        Resource.prototype.getRelationLinkHref = /**
         * @private
         * @param {?} relation
         * @return {?}
         */
        function (relation) {
            if (this._links[relation].templated) {
                return this._links[relation].href.replace('{?projection}', '');
            }
            return this._links[relation].href;
        };
        /**
         * @private
         * @param {?} relation
         * @return {?}
         */
        Resource.prototype.existRelationLink = /**
         * @private
         * @param {?} relation
         * @return {?}
         */
        function (relation) {
            return !Utils.isNullOrUndefined(this._links) && !Utils.isNullOrUndefined(this._links[relation]);
        };
        Resource.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        Resource.ctorParameters = function () { return []; };
        return Resource;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AngularHalModule = /** @class */ (function () {
        function AngularHalModule() {
        }
        /**
         * @return {?}
         */
        AngularHalModule.forRoot = /**
         * @return {?}
         */
        function () {
            return {
                ngModule: AngularHalModule,
                providers: [
                    ExternalService,
                    http.HttpClient,
                    {
                        provide: ResourceService,
                        useClass: ResourceService,
                        deps: [ExternalService]
                    }
                ]
            };
        };
        AngularHalModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [http.HttpClientModule],
                        declarations: [],
                        exports: [http.HttpClientModule],
                        providers: [
                            ExternalService,
                            http.HttpClient,
                            {
                                provide: ResourceService,
                                useClass: ResourceService,
                                deps: [ExternalService]
                            }
                        ]
                    },] }
        ];
        return AngularHalModule;
    }());

    exports.AngularHalModule = AngularHalModule;
    exports.CacheHelper = CacheHelper;
    exports.EvictStrategy = EvictStrategy;
    exports.ExternalService = ExternalService;
    exports.Resource = Resource;
    exports.ResourceArray = ResourceArray;
    exports.ResourceHelper = ResourceHelper;
    exports.RestService = RestService;
    exports.ɵa = ResourceService;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=angular4-hal-redux.umd.js.map
