import { Observable } from 'rxjs';
import { HalOptions } from './rest.service';
import { SubtypeBuilder } from './subtypeBuilder';
export interface Link {
    href: string;
    templated?: boolean;
}
export interface Links {
    [key: string]: Link;
}
export declare abstract class Resource {
    proxyUrl: string;
    rootUrl: string;
    _links: any;
    constructor();
    _subtypes: Map<string, any>;
    subtypes: Map<string, any>;
    getRelation<T extends Resource>(type: new () => T, relation: string, builder?: SubtypeBuilder, expireMs?: number, isCacheActive?: boolean): Observable<T>;
    getRelationArray<T extends Resource>(type: new () => T, relation: string, _embedded?: string, options?: HalOptions, builder?: SubtypeBuilder, expireMs?: number, isCacheActive?: boolean): Observable<T[]>;
    getProjection<T extends Resource>(type: new () => T, resource: string, id: string, projectionName: string, expireMs?: number, isCacheActive?: boolean): Observable<T>;
    getProjectionArray<T extends Resource>(type: new () => T, resource: string, projectionName: string, expireMs?: number, isCacheActive?: boolean): Observable<T[]>;
    addRelation<T extends Resource>(relation: string, resource: T): Observable<any>;
    updateRelation<T extends Resource>(relation: string, resource: T): Observable<any>;
    substituteRelation<T extends Resource>(relation: string, resource: T): Observable<any>;
    deleteRelation<T extends Resource>(relation: string, resource: T): Observable<any>;
    private getResourceUrl;
    private getRelationLinkHref;
    private existRelationLink;
}
