import { HttpClient, HttpHeaders, HttpParams, HttpResponse } from '@angular/common/http';
import { Resource } from './resource';
import { ResourceArray } from './resourceArray';
import { HalOptions, HalParam } from './rest.service';
import { SubtypeBuilder } from './subtypeBuilder';
export interface ResourceExpire<T extends Resource> {
    entity: any;
    expire: number;
}
export declare class ResourceHelper {
    private static proxy_uri;
    private static root_uri;
    private static http;
    private static _headers;
    static headers: HttpHeaders;
    static optionParams(params: HttpParams, options?: HalOptions): HttpParams;
    static params(httpParams: HttpParams, params?: HalParam[]): HttpParams;
    static resolveRelations(resource: Resource): object;
    static createEmptyResult<T extends Resource>(_embedded: string): ResourceArray<T>;
    static getClassName(obj: any): string;
    static className(objProto: any): string[];
    static instantiateResourceFromResponse<T extends Resource>(entity: T, response: HttpResponse<any>): T;
    static instantiateResourceCollection<T extends Resource>(type: new () => T, response: HttpResponse<any>, result: ResourceArray<T>, builder?: SubtypeBuilder): ResourceArray<T>;
    static searchSubtypes<T extends Resource>(builder: SubtypeBuilder, embeddedClassName: string, instance: T): T;
    static instantiateResource<T extends Resource>(entity: T, payload: object): T;
    static setProxyUri(proxy_uri: string): void;
    static setRootUri(root_uri: string): void;
    static getURL(): string;
    static getProxy(uri: string): string;
    static setHttp(http: HttpClient): void;
    static getHttp(): HttpClient;
    static getRootUri(): string;
    private static addSlash;
}
